<link rel="import" href="chrome://resources/html/polymer.html">

<link rel="import" href="chrome://resources/polymer/v1_0/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="chrome://resources/cr_elements/shared_style_css.html">
<link rel="import" href="chrome://resources/cr_elements/shared_vars_css.html">
<link rel="import" href="chrome://resources/html/i18n_behavior.html">
<link rel="import" href="constants.html">
<link rel="import" href="../../settings_shared_css.html">

<dom-module id="album-item">
  <template>
    <style include="settings-shared cr-shared-style iron-flex">
      :host(:not([disabled])) {
        cursor: default;
        display: block;
        outline: none;
      }

      #albumContainer.personal-album {
        margin: 8px 0;
        width: 184px;
      }

      #albumContainer.art-album {
        margin: 8px auto;
        width: 280px;
      }

      #imageContainer {
        background-color: rgba(var(--google-blue-50-rgb), .8);
        border-radius: 8px;
        display: block;
        margin: 0 12px;
        position: relative;
      }

      #imageContainer.personal-album {
        height: 160px;
        width: 160px;
      }

      #imageContainer.art-album {
        height: 160px;
        width: 256px;
      }

      #albumInfo {
        margin: 16px 12px 0 12px;
      }

      #image {
        border-radius: 8px;
        display: block;
        height: 160px;
        object-fit: cover;
        position: absolute;
        transform: scale(1.0);
        transition: transform 240ms;
      }

      #image.personal-album {
        width: 160px;
      }

      #image.art-album {
        width: 256px;
      }

      #rhImages {
        border-radius: 8px;
        display: block;
        height: 160px;
        position: absolute;
        transform: scale(1.0);
        transition: transform 240ms;
        width: 160px;
      }

      .image-rh {
        border-radius: 8px;
        display: block;
        height: 78px;
        position: absolute;
        width: 78px;
      }

      .top-left {
        left: 0;
        top: 0;
      }

      .top-right {
        left: 82px;
        top: 0;
      }

      .bottom-left {
        left: 0;
        top: 82px;
      }

      .bottom-right {
        left: 82px;
        top: 82px;
      }

      .check {
        display: block;
        position: absolute;
        z-index: 1;
      }

      .check.personal-album {
        left: 134px;
        top: 6px;
      }

      .check.art-album {
        left: 230px;
        top: 0;
      }

      :host([checked]) #image {
        box-shadow: 0 4px 8px rgba(32, 33, 36, 0.17);
        transition: transform 240ms;
      }

      :host([checked]) #image.personal-album {
        transform: scale(0.8);
      }

      :host([checked]) #image.art-album {
        transform: scale(0.875);
      }

      :host([checked]) #rhImages {
        transform: scale(0.8);
      }
    </style>
    <div id="albumContainer"
        class$="layout vertical left flex [[computeClass_(topicSource)]]">
      <div id="imageContainer" class$="[[computeClass_(topicSource)]]"
          aria-hidden="true">
        <!-- Only shows the images and icon when the URLs are successfully
             fetched -->
        <template is="dom-if" if="[[album.recentHighlightsUrls]]">
          <div id="rhImages" actionable on-click="onImageClick_">
            <img class="image-rh top-left"
                src="[[album.recentHighlightsUrls.0]]"
                hidden="[[!album.recentHighlightsUrls.0]]">
            </img>
            <img class="image-rh top-right"
                src="[[album.recentHighlightsUrls.1]]"
                hidden="[[!album.recentHighlightsUrls.1]]">
            </img>
            <img class="image-rh bottom-left"
                src="[[album.recentHighlightsUrls.2]]"
                hidden="[[!album.recentHighlightsUrls.2]]">
            </img>
            <img class="image-rh bottom-right"
                src="[[album.recentHighlightsUrls.3]]"
                hidden="[[!album.recentHighlightsUrls.3]]">
            </img>
          </div>
          <iron-icon icon="os-settings:ic-checked-filled"
              class$="check [[computeClass_(topicSource)]]"
              hidden="[[!album.checked]]">
          </iron-icon>
        </template>
        <template is="dom-if" if="[[album.url]]">
          <img id="image" class$="[[computeClass_(topicSource)]]" actionable
              src="[[album.url]]" on-click="onImageClick_">
          </img>
          <iron-icon icon="os-settings:ic-checked-filled"
              class$="check [[computeClass_(topicSource)]]"
              hidden="[[!album.checked]]">
          </iron-icon>
        </template>
      </div>

      <div id="albumInfo" class$="[[computeClass_(topicSource)]]"
          aria-hidden="true">
        <div>[[album.title]]</div>
        <div class="cr-secondary-text">[[album.description]]</div>
      </div>
    </div>
  </template>
  <script src="album_item.js"></script>
</dom-module>
